=== src/contrib/CMakeLists.txt ===
set(contrib_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/environment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/fallingsao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/itemsao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_env.cpp
	PARENT_SCOPE
)
